'''
Created on Dec 19, 2016

@author: klaehn
'''

from time import time
import numpy as np
from engine.engine import engine
from power_sensor.power_sensor import power_sensor

class GateHandler(object):
    """Gate handler class"""
    def __init__(self):
        self.__engine = engine(13, 19)
        self.__power_sensor = power_sensor(1, 0x40)
        self.__max_current = {"up":315, "down":280}
        self.__max_time = {"open":250, "close":250}
        return

    def open(self):
        """Open the gate"""
        timeout_open = time() + self.__max_time["open"]
        self.__engine.run_up()
        power = np.array([])
        timestamps = np.array([])
        while timeout_open > time():
            timestamps = np.append(timestamps, time())
            power = np.append(power, self.__power_sensor.power_mw())

    def close(self):
        """Close the gate"""
        timeout_open = time() + self.__max_time["close"]
        self.__engine.run_down()
        power = np.array([])
        timestamps = np.array([])
        while timeout_open > time():
            timestamps = np.append(timestamps, time())
            power = np.append(power, self.__power_sensor.power_mw())
        